# Generated by Django 3.2.6 on 2021-10-20 17:55

from django.conf import settings
import django.contrib.auth.models
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('first_name', models.CharField(blank=True, max_length=150, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=150, verbose_name='last name')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('email', models.EmailField(max_length=254, unique=True, verbose_name='email address')),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.Group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.Permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'abstract': False,
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='CryptoHourData',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('exchange', models.CharField(blank=True, choices=[('binance', 'binance'), ('bybit', 'bybit'), ('upbit', 'upbit'), ('bithumb', 'bithumb'), ('coinbase', 'coinbase'), ('uniswap', 'uniswap'), ('pancakeswap', 'pancakeswap'), ('kiwoom', 'kiwoom'), ('ebest', 'ebest'), ('shinhan', 'shinhan'), ('robinhood', 'robinhood'), ('alpaca', 'alpaca')], max_length=20, null=True)),
                ('asset_type', models.CharField(blank=True, choices=[('spot', 'spot'), ('margin', 'margin'), ('usdt', 'usdt'), ('coinm', 'coinm'), ('kospi', 'kospi'), ('kosdaq', 'kosdaq'), ('kretf', 'kretf'), ('krfutures', 'krfutures'), ('stock', 'stock'), ('etf', 'etf'), ('futures', 'futures')], max_length=20, null=True)),
                ('symbol', models.CharField(blank=True, max_length=50, null=True)),
                ('symbol_id', models.CharField(blank=True, max_length=100, null=True)),
                ('date', models.CharField(blank=True, max_length=14, null=True)),
                ('open_prc', models.FloatField(blank=True, null=True)),
                ('high_prc', models.FloatField(blank=True, null=True)),
                ('low_prc', models.FloatField(blank=True, null=True)),
                ('close_prc', models.FloatField(blank=True, null=True)),
                ('volume', models.FloatField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='CryptoMinuteData',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('exchange', models.CharField(blank=True, choices=[('binance', 'binance'), ('bybit', 'bybit'), ('upbit', 'upbit'), ('bithumb', 'bithumb'), ('coinbase', 'coinbase'), ('uniswap', 'uniswap'), ('pancakeswap', 'pancakeswap'), ('kiwoom', 'kiwoom'), ('ebest', 'ebest'), ('shinhan', 'shinhan'), ('robinhood', 'robinhood'), ('alpaca', 'alpaca')], max_length=20, null=True)),
                ('asset_type', models.CharField(blank=True, choices=[('spot', 'spot'), ('margin', 'margin'), ('usdt', 'usdt'), ('coinm', 'coinm'), ('kospi', 'kospi'), ('kosdaq', 'kosdaq'), ('kretf', 'kretf'), ('krfutures', 'krfutures'), ('stock', 'stock'), ('etf', 'etf'), ('futures', 'futures')], max_length=20, null=True)),
                ('symbol', models.CharField(blank=True, max_length=50, null=True)),
                ('symbol_id', models.CharField(blank=True, max_length=100, null=True)),
                ('date', models.CharField(blank=True, max_length=14, null=True)),
                ('open_prc', models.FloatField(blank=True, null=True)),
                ('high_prc', models.FloatField(blank=True, null=True)),
                ('low_prc', models.FloatField(blank=True, null=True)),
                ('close_prc', models.FloatField(blank=True, null=True)),
                ('volume', models.FloatField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Fill',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('type', models.CharField(blank=True, max_length=150, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=150, null=True)),
                ('exchange', models.CharField(blank=True, max_length=150, null=True)),
                ('asset_type', models.CharField(blank=True, max_length=150, null=True)),
                ('symbol', models.CharField(blank=True, max_length=150, null=True)),
                ('side', models.CharField(blank=True, max_length=150, null=True)),
                ('direction', models.CharField(blank=True, max_length=150, null=True)),
                ('filled_quantity', models.FloatField(blank=True, max_length=150, null=True)),
                ('order_quantity', models.FloatField(blank=True, max_length=150, null=True)),
                ('fill_cost', models.FloatField(blank=True, max_length=150, null=True)),
                ('est_fill_cost', models.FloatField(blank=True, max_length=150, null=True)),
                ('api_order_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('matcher', models.CharField(blank=True, max_length=150, null=True)),
                ('order_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('signal_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('accno', models.CharField(blank=True, max_length=150, null=True)),
                ('log_time', models.CharField(blank=True, max_length=150, null=True)),
                ('commission', models.FloatField(blank=True, max_length=150, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Log',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=200, null=True)),
                ('source', models.CharField(blank=True, max_length=100, null=True)),
                ('ip_address', models.CharField(blank=True, max_length=30, null=True)),
                ('log_level', models.CharField(blank=True, max_length=20, null=True)),
                ('message', models.TextField(blank=True, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.CreateModel(
            name='Order',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('type', models.CharField(blank=True, max_length=150, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=150, null=True)),
                ('exchange', models.CharField(blank=True, max_length=150, null=True)),
                ('asset_type', models.CharField(blank=True, max_length=150, null=True)),
                ('symbol', models.CharField(blank=True, max_length=150, null=True)),
                ('order_type', models.CharField(blank=True, max_length=150, null=True)),
                ('quantity', models.FloatField(blank=True, max_length=150, null=True)),
                ('price', models.FloatField(blank=True, max_length=150, null=True)),
                ('side', models.CharField(blank=True, max_length=150, null=True)),
                ('direction', models.CharField(blank=True, max_length=150, null=True)),
                ('leverage_size', models.FloatField(blank=True, max_length=150, null=True)),
                ('margin_type', models.CharField(blank=True, max_length=150, null=True)),
                ('invest_amount', models.FloatField(blank=True, max_length=150, null=True)),
                ('signal_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('paired', models.CharField(blank=True, max_length=10, null=True)),
                ('est_fill_cost', models.FloatField(blank=True, max_length=150, null=True)),
                ('matcher', models.CharField(blank=True, max_length=150, null=True)),
                ('status', models.CharField(blank=True, max_length=150, null=True)),
                ('api_order_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('remaining_quantity', models.FloatField(blank=True, max_length=150, null=True)),
                ('log_time', models.CharField(blank=True, max_length=150, null=True)),
                ('order_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('leverage_confirmed', models.CharField(blank=True, max_length=10, null=True)),
                ('margin_type_confirmed', models.CharField(blank=True, max_length=10, null=True)),
                ('transfer_confirmed', models.CharField(blank=True, max_length=10, null=True)),
                ('order_confirmed', models.CharField(blank=True, max_length=10, null=True)),
                ('repay_confirmed', models.CharField(blank=True, max_length=10, null=True)),
                ('repay_needed', models.CharField(blank=True, max_length=10, null=True)),
                ('order_status', models.BooleanField(blank=True, null=True)),
                ('order_fail_point', models.CharField(blank=True, max_length=20, null=True)),
                ('fail_message', models.CharField(blank=True, max_length=300, null=True)),
                ('retry', models.BooleanField(blank=True, null=True)),
                ('retry_num', models.IntegerField(blank=True, null=True)),
                ('retry_cnt', models.IntegerField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='OrderSuccess',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('type', models.CharField(blank=True, max_length=150, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=150, null=True)),
                ('exchange', models.CharField(blank=True, max_length=150, null=True)),
                ('asset_type', models.CharField(blank=True, max_length=150, null=True)),
                ('symbol', models.CharField(blank=True, max_length=150, null=True)),
                ('direction', models.CharField(blank=True, max_length=150, null=True)),
                ('order_uid', models.CharField(blank=True, max_length=150, null=True)),
                ('status', models.CharField(blank=True, max_length=150, null=True)),
                ('fail_point', models.CharField(blank=True, max_length=150, null=True)),
                ('fail_message', models.CharField(blank=True, max_length=150, null=True)),
                ('matcher', models.CharField(blank=True, max_length=150, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='PairSignal',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('type', models.CharField(blank=True, max_length=30, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=200, null=True)),
                ('long_info', models.CharField(blank=True, max_length=150, null=True)),
                ('short_info', models.CharField(blank=True, max_length=150, null=True)),
                ('signal_type', models.CharField(blank=True, choices=[('ENTRY', 'ENTRY'), ('EXIT', 'EXIT')], max_length=5, null=True)),
                ('long_cur_price', models.FloatField(blank=True, null=True)),
                ('short_cur_price', models.FloatField(blank=True, null=True)),
                ('order_type', models.CharField(blank=True, choices=[('MKT', 'MARKET'), ('LMT', 'LIMIT')], max_length=3, null=True)),
                ('log_time', models.CharField(blank=True, max_length=30, null=True)),
                ('signal_uid', models.CharField(blank=True, max_length=50, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Signal',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(blank=True, max_length=200, null=True)),
                ('type', models.CharField(blank=True, max_length=30, null=True)),
                ('strategy_id', models.CharField(blank=True, max_length=200, null=True)),
                ('exchange', models.CharField(blank=True, choices=[('binance', 'binance'), ('bybit', 'bybit'), ('upbit', 'upbit'), ('bithumb', 'bithumb'), ('coinbase', 'coinbase'), ('uniswap', 'uniswap'), ('pancakeswap', 'pancakeswap'), ('kiwoom', 'kiwoom'), ('ebest', 'ebest'), ('shinhan', 'shinhan'), ('robinhood', 'robinhood'), ('alpaca', 'alpaca')], max_length=20, null=True)),
                ('asset_type', models.CharField(blank=True, choices=[('spot', 'spot'), ('margin', 'margin'), ('usdt', 'usdt'), ('coinm', 'coinm'), ('kospi', 'kospi'), ('kosdaq', 'kosdaq'), ('kretf', 'kretf'), ('krfutures', 'krfutures'), ('stock', 'stock'), ('etf', 'etf'), ('futures', 'futures')], max_length=20, null=True)),
                ('symbol', models.CharField(blank=True, max_length=50, null=True)),
                ('signal_type', models.CharField(blank=True, choices=[('ENTRY', 'ENTRY'), ('EXIT', 'EXIT')], max_length=5, null=True)),
                ('signal_price', models.FloatField(blank=True, null=True)),
                ('order_type', models.CharField(blank=True, choices=[('MKT', 'MARKET'), ('LMT', 'LIMIT')], max_length=3, null=True)),
                ('log_time', models.CharField(blank=True, max_length=30, null=True)),
                ('signal_uid', models.CharField(blank=True, max_length=50, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Symbol',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('exchange', models.CharField(blank=True, choices=[('binance', 'binance'), ('bybit', 'bybit'), ('upbit', 'upbit'), ('bithumb', 'bithumb'), ('coinbase', 'coinbase'), ('uniswap', 'uniswap'), ('pancakeswap', 'pancakeswap'), ('kiwoom', 'kiwoom'), ('ebest', 'ebest'), ('shinhan', 'shinhan'), ('robinhood', 'robinhood'), ('alpaca', 'alpaca')], max_length=20, null=True)),
                ('asset_type', models.CharField(blank=True, choices=[('spot', 'spot'), ('margin', 'margin'), ('usdt', 'usdt'), ('coinm', 'coinm'), ('kospi', 'kospi'), ('kosdaq', 'kosdaq'), ('kretf', 'kretf'), ('krfutures', 'krfutures'), ('stock', 'stock'), ('etf', 'etf'), ('futures', 'futures')], max_length=20, null=True)),
                ('symbol', models.CharField(blank=True, max_length=50, null=True)),
                ('symbol_id', models.CharField(blank=True, max_length=100, null=True)),
                ('active', models.BooleanField(blank=True, default=False, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.CreateModel(
            name='UserProfile',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('dob', models.DateField(blank=True, null=True)),
                ('phone', models.CharField(blank=True, max_length=20, null=True)),
                ('address', models.CharField(blank=True, max_length=255, null=True)),
                ('country', models.CharField(blank=True, max_length=50, null=True)),
                ('city', models.CharField(blank=True, max_length=50, null=True)),
                ('zip', models.CharField(blank=True, max_length=5, null=True)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='profile', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Universe',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('public', models.BooleanField(blank=True, default=False, null=True)),
                ('owner', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='universe', to=settings.AUTH_USER_MODEL)),
                ('symbols', models.ManyToManyField(blank=True, null=True, to='db.Symbol')),
            ],
        ),
        migrations.CreateModel(
            name='Strategy',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=200, null=True)),
                ('category', models.CharField(blank=True, max_length=150, null=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('init_time', models.CharField(blank=True, max_length=30, null=True)),
                ('active', models.BooleanField(blank=True, default=False, null=True)),
                ('skip_missed', models.BooleanField(blank=True, default=True, null=True)),
                ('use_frames', models.CharField(blank=True, max_length=100, null=True)),
                ('encrypt_key', models.CharField(blank=True, max_length=250, null=True)),
                ('redis_host', models.CharField(blank=True, max_length=250, null=True)),
                ('redis_port', models.CharField(blank=True, max_length=250, null=True)),
                ('redis_password', models.CharField(blank=True, max_length=250, null=True)),
                ('influxdb_host', models.CharField(blank=True, max_length=250, null=True)),
                ('influxdb_token', models.CharField(blank=True, max_length=250, null=True)),
                ('influxdb_org', models.CharField(blank=True, max_length=250, null=True)),
                ('influxdb_bucket', models.CharField(blank=True, max_length=250, null=True)),
                ('data_server_host', models.CharField(blank=True, max_length=250, null=True)),
                ('data_server_port', models.CharField(blank=True, max_length=250, null=True)),
                ('data_proxy_host', models.CharField(blank=True, max_length=250, null=True)),
                ('data_proxy_market_port', models.CharField(blank=True, max_length=250, null=True)),
                ('data_proxy_account_port', models.CharField(blank=True, max_length=250, null=True)),
                ('data_proxy_bar_port', models.CharField(blank=True, max_length=250, null=True)),
                ('strategy_queue_host', models.CharField(blank=True, max_length=250, null=True)),
                ('strategy_queue_port', models.CharField(blank=True, max_length=250, null=True)),
                ('order_queue_host', models.CharField(blank=True, max_length=250, null=True)),
                ('order_queue_port', models.CharField(blank=True, max_length=250, null=True)),
                ('execution_queue_host', models.CharField(blank=True, max_length=250, null=True)),
                ('execution_queue_port', models.CharField(blank=True, max_length=250, null=True)),
                ('binance_public_key', models.CharField(blank=True, max_length=250, null=True)),
                ('binance_private_key', models.CharField(blank=True, max_length=250, null=True)),
                ('bybit_public_key', models.CharField(blank=True, max_length=250, null=True)),
                ('bybit_private_key', models.CharField(blank=True, max_length=250, null=True)),
                ('upbit_public_key', models.CharField(blank=True, max_length=250, null=True)),
                ('upbit_private_key', models.CharField(blank=True, max_length=250, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('owner', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='owning_strategies', to=settings.AUTH_USER_MODEL)),
                ('universe', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='universe', to='db.universe')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='running_strategies', to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
